import type { CSSProperties, ExtractPropTypes } from 'vue';
import type { FixedDirection, KeyType, RowCommonParams } from './types';
export declare type RowExpandParams = {
    expanded: boolean;
    rowKey: KeyType;
} & RowCommonParams;
export declare type RowHoverParams = {
    event: MouseEvent;
    hovered: boolean;
    rowKey: KeyType;
} & RowCommonParams;
export declare type RowEventHandlerParams = {
    rowKey: KeyType;
    event: Event;
} & RowCommonParams;
export declare type RowHeightChangedParams = {
    rowKey: KeyType;
    height: number;
    rowIndex: number;
};
export declare type RowExpandHandler = (params: RowExpandParams) => void;
export declare type RowHoverHandler = (params: RowHoverParams) => void;
export declare type RowEventHandler = (params: RowEventHandlerParams) => void;
export declare type RowHeightChangeHandler = (row: RowHeightChangedParams, fixedDirection: boolean | FixedDirection | undefined) => void;
export declare type RowEventHandlers = {
    onClick?: RowEventHandler;
    onContextmenu?: RowEventHandler;
    onDblclick?: RowEventHandler;
    onMouseenter?: RowEventHandler;
    onMouseleave?: RowEventHandler;
};
export declare const tableV2RowProps: {
    readonly class: StringConstructor;
    readonly columns: import("element-pe/es/utils").BuildPropReturn<import("element-pe/es/utils").PropWrapper<import("./common").AnyColumn[]>, unknown, true, unknown, unknown>;
    readonly columnsStyles: import("element-pe/es/utils").BuildPropReturn<import("element-pe/es/utils").PropWrapper<Record<KeyType, CSSProperties>>, unknown, true, unknown, unknown>;
    readonly depth: NumberConstructor;
    readonly expandColumnKey: StringConstructor;
    readonly estimatedRowHeight: {
        readonly default: undefined;
        readonly type: import("vue").PropType<number>;
        readonly required: false;
        readonly validator: ((val: unknown) => boolean) | undefined;
        readonly __elPropsReservedKey: true;
    };
    readonly isScrolling: BooleanConstructor;
    readonly onRowExpand: import("element-pe/es/utils").BuildPropReturn<import("element-pe/es/utils").PropWrapper<RowExpandHandler>, unknown, unknown, unknown, unknown>;
    readonly onRowHover: import("element-pe/es/utils").BuildPropReturn<import("element-pe/es/utils").PropWrapper<RowHoverHandler>, unknown, unknown, unknown, unknown>;
    readonly onRowHeightChange: import("element-pe/es/utils").BuildPropReturn<import("element-pe/es/utils").PropWrapper<RowHeightChangeHandler>, unknown, unknown, unknown, unknown>;
    readonly rowData: import("element-pe/es/utils").BuildPropReturn<import("element-pe/es/utils").PropWrapper<any>, unknown, true, unknown, unknown>;
    readonly rowEventHandlers: import("element-pe/es/utils").BuildPropReturn<import("element-pe/es/utils").PropWrapper<RowEventHandlers>, unknown, unknown, unknown, unknown>;
    readonly rowIndex: import("element-pe/es/utils").BuildPropReturn<NumberConstructor, unknown, true, unknown, unknown>;
    readonly rowKey: import("element-pe/es/utils").BuildPropReturn<import("element-pe/es/utils").PropWrapper<KeyType>, "id", unknown, unknown, unknown>;
    readonly style: import("element-pe/es/utils").BuildPropReturn<import("element-pe/es/utils").PropWrapper<CSSProperties>, unknown, unknown, unknown, unknown>;
};
export declare type TableV2RowProps = ExtractPropTypes<typeof tableV2RowProps>;
